' ------------------------------------------------------------------------------------
'					Export2SMB.vbs
' This script will export the current album to a script compatible with
' StereoMovieBuilder.
' ------------------------------------------------------------------------------------
Option Explicit

const FrameRate = 25		' Frame per second in movie
const DefaultFadeDelay = 1	' Default fade duration
const wSize = 320		' Target width of the video
const hSize = 240		' Target height of the video
const kbeCF = "KBSE"
const bUsePath = true

app.cleartrace
Dim fso, f
Set fso = CreateObject("Scripting.FileSystemObject")
Const ForReading = 1, ForWriting = 2

' Define the variables
dim alb, nb, i, k, pic, scriptFile, d, s, sPic, sLastPic, dT, nPicType, nbP, nbS, kbe, lastkbe, Tkbe, tr2kbe, sPath
dim sTransName

set alb = app.GetCurrentAlbum
nb = alb.nbPicture
app.Trace "Pictures in this album: " & nb, -1, TRACE_INFORMATION

scriptFile = alb.ExpandMacro( Nothing, "%Af" ) & "\" & "AnimSMB_" & Left(alb.Name, InStrRev(alb.Name, ".")-1 ) & ".txt"
app.Trace "Saving script file in '" & scriptFile & "'..."

Set f = fso.OpenTextFile( scriptFile, ForWriting, True )
f.Write "; Script for StereoMovie Builder" & vbCRLF
f.Write "; Exported from: '" & alb.name & "' album on " & now & vbCRLF
f.Write vbCRLF

f.Write ">FrameRate=" & FrameRate & vbCRLF
f.Write ">Resize=" & (2*wSize) & "x" & hSize & vbCRLF
f.Write ">ResizeMode=1" & vbCRLF
f.Write ">Stereo=1" & vbCRLF
f.Write vbCRLF

sLastPic = ""
nbP = 0
nbS = 0
sPath = ""
lastkbe = ""
for i = 0 to nb-1
  Set pic = alb.GetPicture(i)
  if pic.bSelected then
    sPic = alb.ExpandMacro( pic, "%RP" )
    if bUsePath then
      if sPath = "" then
	k = InStrRev( sPic, "\" )
	sPath = Left( sPic, k )
	app.Trace "Using path: " & sPath
	f.Write ">Path=" & sPath & vbCRLF & vbCRLF
'f.write "E:\DONNEES\pm027276\Images\Diaporama\LaLibertad\BlackFrame.png" & vbCRLF & vbCRLF
      end if
      if sPath & pic.sShortFileName = sPic then sPic = pic.sShortFileName
    end if
    
    d = pic.lTransition and 65535
    if d = 65535 then d = alb.nDelaySlideshow
    nPicType = pic.lStatus and &hff
    kbe = pic.GetCustomField( kbeCF )
    if nPicType <> 31 then
      if sLastPic <> "" and ((pic.lStatus and STATE_USETRANSITION) <> 0) and pic.transitionID <> "" then
	dT = CLng((pic.lTransition and &h7fff0000) / 65536)
	if dT = 0 then dT = 10 * DefaultFadeDelay
	tr2kbe = ""
	if kbe <> "" or lastkbe <> "" then
	  if lastkbe <> "" then
	    Tkbe = split( lastkbe, "|" )
	    tr2kbe = "|" & left( Tkbe(1), InStrRev(Tkbe(1), ",")-1)
	  else
	    tr2kbe = "|0,0,0,0"
	  end if
	  if kbe <> "" then
	    Tkbe = split( kbe, "|" )
	    tr2kbe = tr2kbe & "|" & left( Tkbe(0), InStrRev(Tkbe(0), ",")-1)
	  else
	    tr2kbe = tr2kbe & "|0,0,0,0"
	  end if
	end if
	if tr2kbe = "|0,0,0,0|0,0,0,0" then tr2kbe = ""
	sTransName = getTransition(pic.transitionID)
	f.Write ">Transition=" & sTransName & "|" & Replace((dT / 10),",",".") & vbCRLF
	'f.Write ">Transition=" & sLastPic & "|" & sPic & "|Fade|" & round(dT / 10 * FrameRate) & tr2kbe & vbCRLF
	d = d - dT
	if d < 0 then d = 1
      end if
      s = d / 10
    
      'app.Trace i & vbtab & hex(pic.lTransition) & vbtab & CLng((pic.lTransition and &h7fff0000) / 65536) & vbtab & d
      'app.Trace i & vbtab & pic.transitionID
      if kbe = "" then 
        f.Write sPic & vbTab & vbTab & "*" & Replace(s,",",".") & vbCRLF
      else
        f.Write ">KBE=" & sPic & "|" & kbe & vbCRLF & vbCRLF
      end if
      sLastPic = sPic
      nbP = nbP + 1
    else
      'f.Write "; Caution: " & sPic & " is a video file. Not processed." & vbCRLF
      f.Write ">Video=" & sPic & vbCRLF
      sLastPic = ""
      'nbS = nbS + 1
    end if
    lastkbe = kbe
  end if
next
f.Write vbCRLF
f.Write ">Stop=1" & vbCRLF
f.Write ";  " & nbP & " pictures processed  (" & nbS & " skipped)" & vbCRLF
f.Write "; Done!" & vbCRLF
f.close

alb.ReDraw
app.trace "Done !", -1, TRACE_GREENDOT

' ------------------------------------------------------------------------------------
function getNextPic( pic )
  set getNextPic = pic.Next
  do
    if getNextPic is Nothing then exit do
    if getNextPic.bSelected then exit do
    set getNextPic = getNextPic.Next
  loop while True
end function

' ------------------------------------------------------------------------------------
function getTransition( clsid )
select case clsid
  case "{107045D1-06E0-11D2-8D6D-00C04F8EF8E0}":
	getTransition = "MetaCreations Burn Film"
  case "{AA0D4D0C-06A3-11D2-8F98-00C04FB92EB7}":
	getTransition = "MetaCreations Center Curls"
  case "{2A54C908-07AA-11D2-8D6D-00C04F8EF8E0}":
	getTransition = "MetaCreations Color Fade"
  case "{AA0D4D0E-06A3-11D2-8F98-00C04FB92EB7}":
	getTransition = "MetaCreations Curls"
  case "{AA0D4D12-06A3-11D2-8F98-00C04FB92EB7}":
	getTransition = "MetaCreations Curtains"
  case "{107045CC-06E0-11D2-8D6D-00C04F8EF8E0}":
	getTransition = "MetaCreations Fade White"
  case "{2A54C90B-07AA-11D2-8D6D-00C04F8EF8E0}":
	getTransition = "MetaCreations Flow Motion"
  case "{2A54C913-07AA-11D2-8D6D-00C04F8EF8E0}":
	getTransition = "MetaCreations Glass Block"
  case "{2A54C911-07AA-11D2-8D6D-00C04F8EF8E0}":
	getTransition = "MetaCreations Grid"
  case "{2A54C904-07AA-11D2-8D6D-00C04F8EF8E0}":
	getTransition = "MetaCreations Jaws"
  case "{107045CA-06E0-11D2-8D6D-00C04F8EF8E0}":
	getTransition = "MetaCreations Lens"
  case "{107045C8-06E0-11D2-8D6D-00C04F8EF8E0}":
	getTransition = "MetaCreations Light Wipe"
  case "{AA0D4D0A-06A3-11D2-8F98-00C04FB92EB7}":
	getTransition = "MetaCreations Liquid"
  case "{AA0D4D08-06A3-11D2-8F98-00C04FB92EB7}":
	getTransition = "MetaCreations Page Curl"
  case "{AA0D4D10-06A3-11D2-8F98-00C04FB92EB7}":
	getTransition = "MetaCreations Peel ABCD"
  case "{AA0D4D03-06A3-11D2-8F98-00C04FB92EB7}":
	getTransition = "MetaCreations Ripple"
  case "{9C61F46E-0530-11D2-8F98-00C04FB92EB7}":
	getTransition = "MetaCreations Roll Down"
  case "{2A54C915-07AA-11D2-8D6D-00C04F8EF8E0}":
	getTransition = "MetaCreations Threshold"
  case "{107045CF-06E0-11D2-8D6D-00C04F8EF8E0}":
	getTransition = "MetaCreations Twister"
  case "{2A54C90D-07AA-11D2-8D6D-00C04F8EF8E0}":
	getTransition = "MetaCreations Vacuum"
  case "{107045C5-06E0-11D2-8D6D-00C04F8EF8E0}":
	getTransition = "MetaCreations Water"
  case "{0E6AE022-0C83-11D2-8CD4-00104BC75D9A}":
	getTransition = "MetaCreations Wormhole"
  case "{EC9BA17D-60B5-462B-A6D8-14B89057E22A}":
	getTransition = "Barn"
  case "{9A4A4A51-FB3A-4F4B-9B57-A2912A289769}":
	getTransition = "Blinds"
  case "{B3EE7802-8224-4787-A1EA-F0DE16DEABD3}":
	getTransition = "CheckerBoard"
  case "{C3BDF740-0B58-11D2-A484-00C04F8EFB69}":
	getTransition = "CrBarn"
  case "{00C429C0-0BA9-11D2-A484-00C04F8EFB69}":
	getTransition = "CrBlinds"
  case "{93073C40-0BA5-11D2-A484-00C04F8EFB69}":
	getTransition = "CrInset"
  case "{3F69F351-0379-11D2-A484-00C04F8EFB69}":
	getTransition = "CrIris"
  case "{424B71AF-0695-11D2-A484-00C04F8EFB69}":
	getTransition = "CrRadialWipe"
  case "{810E402F-056B-11D2-A484-00C04F8EFB69}":
	getTransition = "CrSlide"
  case "{ACA97E00-0C7D-11D2-A484-00C04F8EFB69}":
	getTransition = "CrSpiral"
  case "{7658F2A2-0A83-11D2-A484-00C04F8EFB69}":
	getTransition = "CrStretch"
  case "{5AE1DAE0-1461-11D2-A484-00C04F8EFB69}":
	getTransition = "Wheel"
  case "{E6E73D20-0C8A-11D2-A484-00C04F8EFB69}":
	getTransition = "CrZigzag"
  case "{16B280C5-EE70-11D1-9066-00C04FD9189D}":
	getTransition = "Fade"
  case "{B96F67A2-30C2-47E8-BD85-70A2C948B50F}":
	getTransition = "GradientWipe"
  case "{76F363F2-7E9F-4ED7-A6A7-EE30351B6628}":
	getTransition = "Inset"
  case "{049F2CE6-D996-4721-897A-DB15CE9EB73D}":
	getTransition = "Iris"
  case "{4CCEA634-FBE0-11D1-906A-00C04FD9189D}":
	getTransition = "Pixelate"
  case "{164484A9-35D9-4FB7-9FAB-48273B96AA1D}":
	getTransition = "RadialWipe"
  case "{2E7700B7-27C4-437F-9FBF-1E8BE2817566}":
	getTransition = "RandomBars"
  case "{F7F4A1B6-8E87-452F-A2D7-3077F508DBC0}":
	getTransition = "RandomDissolve"
  case "{E31E87C4-86EA-4940-9B8A-5BD5D179A737}":
	getTransition = "RevealTrans"
  case "{D1C5A1E7-CC47-4E32-BDD2-4B3C5FC50AF5}":
	getTransition = "Slide"
  case "{4A03DCB9-6E17-4A39-8845-4EE7DC5331A5}":
	getTransition = "Spiral"
  case "{F088DE73-BDD0-4E3C-81F8-6D32F4FE9D28}":
	getTransition = "Stretch"
  case "{63A4B1FC-259A-4A5B-8129-A83B8C9E6F4F}":
	getTransition = "Strips"
  case "{AF279B30-86EB-11D1-81BF-0000F87557DB}":
	getTransition = "Wipe"
  case "{23E26328-3928-40F2-95E5-93CAD69016EB}":
	getTransition = "ZigZag"
  case else
  	getTransition = "Fade"
end select
end function